<script lang="ts">
  import hljs from 'highlight.js/lib/core';
  import coffeescript from 'highlight.js/lib/languages/coffeescript';
  import 'highlight.js/styles/atom-one-light.css';
  import { focusElement } from '$lib';
  import { routes, policies, data, input, successMessage, errorMessage } from '$lib/stores';
  import Sidebar from '$lib/Sidebar.svelte';
  import SuccessMessage from '$lib/SuccessMessage.svelte';
  import ErrorMessage from '$lib/ErrorMessage.svelte';
  import Dropdown from '$lib/Dropdown.svelte';
  import DeleteButton from '$lib/DeleteButton.svelte';

  hljs.registerLanguage('coffeescript', coffeescript); // Note: CoffeeScript used, since highlight.js has no support for Rego yet

  // Reset success and error messages on page load
  successMessage.set('');
  errorMessage.set('');

  // addLines adds line numbers to the code and highlights the lines based on coverage. Note: not using e.g. highlightjs-line-numbers.js, since we also want to add coverage
  function addLines(input: string, coverage: CoverageFileReport): string {
    return input
      .split('\n') // Split the input string into lines
      .map(
        // Wrap each line in a <div>
        (line, i) => {
          const lineNumber = i + 1;
          let extraClass = '';

          // Add an extra class for covered and not-covered lines (note: some lines are neither)
          if (
            coverage.covered.find(
              (range) => range.start.row <= lineNumber && lineNumber <= range.end.row,
            )
          ) {
            extraClass = 'covered';
          } else if (
            coverage.not_covered.find(
              (range) => range.start.row <= lineNumber && lineNumber <= range.end.row,
            )
          ) {
            extraClass = 'not-covered';
          }

          return `<div class="line ${extraClass}"><span class="line-number">${lineNumber}</span>${line}</div>`;
        },
      )
      .join(''); // Join the lines back together
  }

  type CoverageRange = {
    start: {
      row: number;
    };
    end: {
      row: number;
    };
  };

  type CoverageFileReport = {
    covered: CoverageRange[];
    not_covered: CoverageRange[];
    // Note: ignored attributes covered_lines (int), not_covered_lines (int) and coverage (float64)
  };

  let result: {
    isAllowed: boolean;
    module?: string;
    coverage?: CoverageFileReport;
    trace?: string;
  };

  function run(): void {
    let str = JSON.stringify({
      routes: $routes,
      policies: $policies,
      data: $data,
      input: $input,
    });

    const response = runRego(str);

    try {
      result = JSON.parse(response);
    } catch (error: any) {
      console.log(error);

      result = { isAllowed: false, trace: `Error: ${response}` };
    }
  }

  const methodColors: {
    [key: string]: string;
  } = {
    GET: 'blue',
    POST: 'emerald',
    PUT: 'amber',
    DELETE: 'rose',
    PATCH: 'teal',
    HEAD: 'violet',
    OPTIONS: 'cyan',
    TRACE: 'slate',
    CONNECT: 'slate',
  };
</script>

<svelte:head>
  <title>Playground — FSC Policy Builder</title>
</svelte:head>

<div class="grid min-h-screen grid-cols-12">
  <Sidebar active="playground" />

  <div class="col-span-7 bg-slate-50 p-6 sm:col-span-8 lg:col-span-9">
    <h1 class="mb-5 text-2xl font-medium">Playground</h1>

    {#if $errorMessage}
      <ErrorMessage bind:message={$errorMessage} />
    {:else if $successMessage}
      <SuccessMessage bind:message={$successMessage} />
    {/if}

    <form on:submit|preventDefault={run} class="mb-7">
      <h2 class="mb-3 text-xl font-medium">Invoer</h2>

      <label class="mb-2 block font-medium text-gray-600" for="route">Route</label>
      <div class="mb-5 flex">
        <Dropdown
          extraClasses="rounded-r-none -mr-px relative z-10 hover:z-20 focus:z-20 !shadow-none"
          bind:value={$input.method}
          options={[
            { value: 'GET', label: 'GET' },
            { value: 'POST', label: 'POST' },
            { value: 'PUT', label: 'PUT' },
            { value: 'DELETE', label: 'DELETE' },
            { value: 'PATCH', label: 'PATCH' },
            { value: 'HEAD', label: 'HEAD' },
            { value: 'OPTIONS', label: 'OPTIONS' },
            { value: 'TRACE', label: 'TRACE' },
            { value: 'CONNECT', label: 'CONNECT' },
          ]}
          color={methodColors[$input.method]}
        />
        <input
          bind:value={$input.path}
          use:focusElement
          type="text"
          id="route"
          class="relative grow rounded-r-lg border border-gray-300 px-2.5 py-1.5 text-gray-800 placeholder:text-gray-400 focus:z-20 focus:border-indigo-500 focus:outline-none focus:ring-1 focus:ring-indigo-500"
          placeholder="Bijvoorbeeld /test"
          autocomplete="off"
        />
      </div>

      <p class="mb-2 font-medium text-gray-600">
        HTTP request headers <span class="font-normal text-gray-400">(optioneel)</span>
      </p>

      {#each $input.requestHeaders as _, i}
        <div class="mb-3 flex items-center">
          <input
            bind:value={$input.requestHeaders[i].key}
            use:focusElement
            type="text"
            class="relative grow rounded-l-lg border border-gray-300 px-2.5 py-1.5 text-gray-800 placeholder:text-gray-400 focus:z-10 focus:border-indigo-500 focus:outline-none focus:ring-1 focus:ring-indigo-500"
            placeholder="Veld, bijvoorbeeld Accept"
            autocomplete="off"
          />
          <span class="border-y border-gray-300 bg-gray-50 px-2.5 py-1.5 text-gray-800">:</span>
          <input
            bind:value={$input.requestHeaders[i].value}
            type="text"
            class="relative grow-[3] rounded-r-lg border border-gray-300 px-2.5 py-1.5 text-gray-800 placeholder:text-gray-400 focus:z-10 focus:border-indigo-500 focus:outline-none focus:ring-1 focus:ring-indigo-500"
            placeholder="Waarde, bijvoorbeeld application/json"
            autocomplete="off"
          />

          <DeleteButton
            on:click={() => {
              $input.requestHeaders = [
                ...$input.requestHeaders.slice(0, i),
                ...$input.requestHeaders.slice(i + 1),
              ];
            }}
            extraClasses="!mt-0 !mb-0 !ml-1"
          />
        </div>
      {:else}
        <p class="text-gray-500 mb-3">Nog geen headers.</p>
      {/each}

      <button
        on:click={() => {
          $input.requestHeaders = [
            ...$input.requestHeaders,
            {
              key: '',
              value: '',
            },
          ];
        }}
        class="mb-5 inline-flex items-center rounded-lg border border-indigo-300 bg-white px-2.5 py-1.5 text-sm font-medium text-indigo-800 shadow-sm hover:border-indigo-400 hover:bg-indigo-100 hover:text-indigo-900 focus:outline-none focus:ring-4 focus:ring-indigo-100"
        type="button"
      >
        <svg class="-ml-0.5 mr-2 h-4 w-4" xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24">
          <path
            fill="none"
            stroke="currentColor"
            stroke-linecap="round"
            stroke-linejoin="round"
            stroke-width="2"
            d="M12 5v14m-7-7h14"
          />
        </svg>
        Voeg header toe
      </button>

      <label class="mb-3 block font-medium text-gray-600" for="fsc-peer-id">
        FSC peer ID <span class="font-normal text-gray-400">(optioneel)</span>
      </label>
      <input
        bind:value={$input.fscPeerId}
        type="text"
        id="fsc-peer-id"
        class="mb-7 block w-full rounded-lg border border-gray-300 px-2.5 py-1.5 text-gray-800 placeholder:text-gray-400 focus:z-10 focus:border-indigo-500 focus:outline-none focus:ring-1 focus:ring-indigo-500"
        placeholder="Bijvoorbeeld 1234567890"
        autocomplete="off"
      />

      <button
        type="submit"
        class="inline-flex items-center rounded-lg border border-indigo-600 bg-indigo-500 px-4 py-2.5 text-sm font-medium text-white shadow-sm hover:border-indigo-700 hover:bg-indigo-600 focus:outline-none focus:ring-4 focus:ring-indigo-200"
      >
        <svg class="-ml-0.5 mr-1.5 h-5 w-5" xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24"
          ><path
            d="M5 5v14a2 2 0 0 0 2.75 1.84L20 13.74a2 2 0 0 0 0-3.5L7.75 3.14A2 2 0 0 0 5 4.89"
            fill="none"
            stroke="currentColor"
            stroke-width="2"
            stroke-linecap="round"
            stroke-linejoin="round"
          /></svg
        >
        Evalueer
      </button>
    </form>

    {#if result}
      <div class="">
        <h2 class="mb-3 text-xl font-medium">Resultaat</h2>
        <p class="mb-8">
          {#if result.isAllowed}
            <span class="inline-block rounded bg-emerald-100 px-2 py-1.5 text-sm text-emerald-800"
              >Toegestaan</span
            >
          {:else}
            <span class="inline-block rounded bg-rose-100 px-2 py-1.5 text-sm text-rose-800"
              >Geweigerd</span
            >
          {/if}
        </p>

        {#if result.module}
          <p class="mb-2 font-medium text-gray-600">Resulterende code</p>
          <div class="mb-2 rounded-md border border-slate-300 bg-slate-100 p-4 font-mono text-xs">
            <code
              >{@html addLines(
                hljs.highlight(result.module, { language: 'coffeescript' }).value,
                result.coverage || { covered: [], not_covered: [] },
              )}</code
            >
          </div>
          <p class="mb-8 text-sm text-gray-500">
            <span class="rounded-sm bg-emerald-200/75 px-1 py-0.5">Groene regels</span> zijn
            bereikt.
            <span class="rounded-sm bg-rose-200/75 px-1 py-0.5">Rode regels</span> zijn niet bereikt
            tijdens de evaluatie.
          </p>
        {/if}

        <p class="mb-2 font-medium text-gray-600">Details</p>
        <pre class="whitespace-pre-wrap font-mono text-xs">{result.trace}</pre>
      </div>
    {/if}
  </div>
</div>

<style lang="postcss">
  :global(code .line) {
    @apply whitespace-pre-wrap rounded-sm pl-10;
  }

  /* Avoid rounded corners for adjacent lines of the same color. Note: an alternative would be to use the `start` and `end` attributes from the coverage ranges */
  :global(code .line.covered + .line.covered, code .line.not-covered + .line.not-covered) {
    @apply rounded-t-none;
  }

  :global(
      code .line.covered:has(+ .line.covered),
      code .line.not-covered:has(+ .line.not-covered)
    ) {
    @apply rounded-b-none;
  }

  :global(code .line.covered) {
    @apply bg-emerald-200/75;
  }

  :global(code .line.not-covered) {
    @apply bg-rose-200/75;
  }

  :global(code .line-number) {
    @apply -ml-10 inline-block w-10 select-none pr-3 text-right text-slate-500;
  }
</style>
